package example;

import dao.merchantsAbstractDAO;
import dao.specification.merchantsDAO;
import dao.specification.userDAO;
import dao.userAbstractDAO;
import entities.Merchants;
import entities.Users;
import util.Toolset;

import java.util.Scanner;

public class shellUI {
    public static void main(String[] args) throws IllegalAccessException {
        run();
    }

    public static void run() throws IllegalAccessException {

        System.out.println("""
                ------------------------------------------
                ----------------后台管理系统----------------
                ------------------------------------------
                """);
        Chose();
    }

    //选项一
    private static void Chose() throws IllegalAccessException {
        System.out.println("""
                请选择你要进行的功能:
                1.商家管理\t2.用户管理\t0.退出
                """);

        switch (Toolset.option()) {
            case 0 -> System.exit(0);
            //商家
            case 1 -> {
                System.out.println("""
                        请选择你想使用的功能:
                        1.新建商家\t\t2.删除商家\t\t3.更新信息
                        4.查询所有商家\t5.根据ID查询商家\t0.退出
                        """);
                merchantsDB(Toolset.option());
                Chose();
            }
            //用户
            case 2 -> {
                System.out.println("""
                        请选择你想使用的功能:
                        1.新建用户\t\t2.删除用户\t\t3.更新信息
                        4.查询所有用户\t5.根据ID查询用户\t0.退出
                        """);
                userDB(Toolset.option());
                Chose();
            }
        }
    }

    //商家数据库操作
    private static void merchantsDB(int chose) throws IllegalAccessException {
        int flag;
        Merchants merchants;
        Scanner reader = new Scanner(System.in);
        switch (chose) {
            case 0 -> System.exit(0);
            case 1 -> {//@TODO 输入格式化 不换行
                merchantsAbstractDAO DML_insert = new merchantsDAO();
                System.out.println("请输入：店铺名字|地址|描述|电话");
                merchants = new Merchants(reader.nextLine(), reader.nextLine(), reader.nextLine(), reader.nextLine());
                flag = DML_insert.insert(merchants);
                System.out.println(flag + "行受影响");
            }
            case 2 -> {
                merchantsAbstractDAO DML_delete = new merchantsDAO();
                merchants = new Merchants();

                System.out.println("请输入你要删除商家的ID");
                merchants.setId(reader.nextLong());

                flag = DML_delete.delete(merchants);
                System.out.println(flag + "行受影响");
            }
            case 3 -> {
                merchantsAbstractDAO DML_update = new merchantsDAO();
                merchants = new Merchants();
                flag = DML_update.update(merchants);
                System.out.println(flag + "行受影响");
            }
            case 4 -> {
                merchantsAbstractDAO DQL_all = new merchantsDAO();
                merchants = new Merchants();
                //格式化输出
                for (Merchants item : DQL_all.search(merchants)) {
                    System.out.println(Toolset.table(Merchants.class, item));
                }

            }
            case 5 -> {
                merchantsAbstractDAO DQL_ID = new merchantsDAO();
                new Merchants();
                System.out.println("请输入你要查询的ID:");
                merchants = DQL_ID.searchID(reader.nextLong());
                //格式化输出
                System.out.println(Toolset.table(Merchants.class, merchants));
            }
        }
    }

    //用户数据库操作
    private static void userDB(int chose) throws IllegalAccessException {
        int flag;
        Users user;
        Scanner reader = new Scanner(System.in);

        switch (chose) {
            case 0 -> System.exit(0);
            case 1 -> {//@TODO 非换行输入
                userAbstractDAO DML_insert = new userDAO();
                System.out.println("请输入：名字|电话|地址|密码");
                user = new Users(reader.nextLine(), reader.nextLine(), reader.nextLine(), reader.nextLine());
                flag = DML_insert.insert(user);
                System.out.println(flag + "行受影响");
            }
            case 2 -> {
                userAbstractDAO DML_delete = new userDAO();
                user = new Users();
                flag = DML_delete.delete(user);
                System.out.println(flag + "行受影响");
            }
            case 3 -> {
                userAbstractDAO DML_update = new userDAO();
                user = new Users();
                flag = DML_update.update(user);
                System.out.println(flag + "行受影响");
            }
            case 4 -> {
                userAbstractDAO DQL_all = new userDAO();
                user = new Users();
                //格式化输出
                for (Users item : DQL_all.search(user)) {
                    System.out.println(Toolset.table(Users.class, item));
                }

            }
            case 5 -> {
                userAbstractDAO DQL_ID = new userDAO();
                new Users();
                System.out.println("请输入你要查询的ID:");
                user = DQL_ID.searchID(reader.nextLong());
                //格式化输出
                System.out.println(Toolset.table(Users.class, user));
            }
        }
    }

}
